%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%define srcname docker_registry

Summary:        Registry server for Docker
Name:           docker-registry
Version:        0.9.1
%define subrel 1
Release:        %mkrel 1
Group:          System/Configuration
License:        ASL 2.0
URL:            https://github.com/docker/%{name}
Source:         https://github.com/docker/%{name}/archive/%{version}.tar.gz
Source1:        docker-registry.service
Source2:        docker-registry.sysconfig
# Support for older Redis Python binding in EPEL
#Patch0:			Don-t-use-flask-cors-not-available-in-Mageia-yet.patch

BuildRequires:    python-devel
BuildRequires:      systemd
Requires(post):     systemd
Requires(preun):    systemd
Requires(postun):   systemd
Requires:       python-boto
Requires:       python-flask
Requires:       PyYAML
Requires:       python-argparse
Requires:       python-simplejson
Requires:       python-requests
Requires:       python-gunicorn
Requires:       python-gevent
Requires:       python-blinker
Requires:       python-flask
Recommends:       python-glanceclient
Recommends:       python-keystoneclient
Requires:       python-redis
Requires:       python-rsa
Requires:       python-backports-lzma
Requires:       python-jinja2
Requires:       python-sqlalchemy
Requires:       python-m2crypto
Requires:       redis
BuildArch:      noarch
Requires(post):   rpm-helper >= %{rpmhelper_required_version}
Requires(preun):  rpm-helper >= %{rpmhelper_required_version}

%description
Registry server for Docker (hosting/delivering of repositories and images).

%prep
%setup -q -n %{name}-%{version}

# Remove the golang implementation
# It's not the main one (yet?)
rm -rf contrib/golang_impl

%build
%{__python} setup.py build

%install

%define cachedir %{_var}/cache/docker
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{cachedir}
install -d %{buildroot}%{python_sitelib}/%{name}/%{srcname}
install -d %{buildroot}%{python_sitelib}/%{name}/config

install -pm 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/%{srcname}

install -d %{buildroot}%{_unitdir}
install -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/%{srcname}.service

# Make sure we set proper WorkingDir in the systemd service file
perl -pi -e "s|#WORKDIR#|%{python_sitelib}/%{name}|" %{buildroot}%{_unitdir}/%{srcname}.service

cp -pr %{srcname} tests %{buildroot}%{python_sitelib}/%{name}
cp config/config_sample.yml %{buildroot}%{_sysconfdir}/%{srcname}.yml

cp -r depends/%{name}-core/%{srcname}/* %{buildroot}%{python_sitelib}/%{name}/%{srcname}

echo "local:
    <<: *dev
    storage: local
    storage_path: %{cachedir}" >> %{buildroot}%{_sysconfdir}/%{srcname}.yml

ln -sf %{_sysconfdir}/%{srcname}.yml %{buildroot}/%{python_sitelib}/%{name}/config/config.yml

%post
%_post_service %{srcname}

%preun
%_preun_service %{srcname}

#%postun
#%_postun_service %{srcname}

%files
%doc %{python_sitelib}/%{name}/%{srcname}/extensions/README.md
%doc LICENSE AUTHORS *.md
%dir %{python_sitelib}/%{name}
%config(noreplace) %{_sysconfdir}/%{srcname}.yml
%config(noreplace) %{_sysconfdir}/sysconfig/%{srcname}
%dir %{python_sitelib}/%{name}/config
%{python_sitelib}/%{name}/config/config.yml
%{python_sitelib}/%{name}/%{srcname}/*.py*
%{python_sitelib}/%{name}/%{srcname}/*/*.py*
%{python_sitelib}/%{name}/%{srcname}/lib/index/*.py*
%{python_sitelib}/%{name}/tests/*.py*
%{python_sitelib}/%{name}/tests/*/*.yaml
%{python_sitelib}/%{name}/tests/lib/index/*.py*
%{python_sitelib}/%{name}/tests/*/*.py*
%{python_sitelib}/%{name}/tests/data/*/*
%dir %{cachedir}
%{_unitdir}/%{srcname}.service


%changelog
* Thu Jun 25 2015 bcornec <bcornec> 0.9.1-1.1.mga5
+ Revision: 842712
- Fix #16192 by using mageia macros

* Mon Feb 23 2015 bcornec <bcornec> 0.9.1-1.mga5
+ Revision: 816694
- Fix dependencies (recommends openstack modules, remove obsolete python-deocker-registry-core)
- Update docker-registry to 0.9.1 and place content under /var/cache and solve gunicorn startup

* Fri Nov 28 2014 bcornec <bcornec> 0.9.0-1.mga5
+ Revision: 799714
- Merge with some additional content from docker-io-registry which should now be removed
- Update docker-registry to upstream 0.9.0 and remove now useless patches
- Update to upstream 0.9.0

* Wed Oct 15 2014 umeabot <umeabot> 0.8.1-4.mga5
+ Revision: 745900
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0.8.1-3.mga5
+ Revision: 678795
- Mageia 5 Mass Rebuild

* Wed Sep 10 2014 bcornec <bcornec> 0.8.1-2.mga5
+ Revision: 674588
- docker-registry now install and is launched via systemd correctly

* Wed Sep 03 2014 bcornec <bcornec> 0.8.1-1.mga5
+ Revision: 671199
- Fix Group entry for docker-registry
- Import docker-registry from fedora with mageia adaptations
- Created package structure for docker-registry.

